// -*- Mode:C++ -*-
//Header:
//File: bipredutil.h
//Title: built-in predicate 
//Author: NODA Itsuki
//Date: 1998/6/19
//EndHeader:

//ModifyHistory:
// 1998/6/19: Create this file
//EndModifyHistory:

//Memo:
//EndMemo:

//======================================================================
// Built-In Predicate Utility
//

inline bool chkArity(GData& gterm, UInt n) {
   return isGTerm(gterm) && _TermArity(gterm) == n ;
} ;
inline bool chkArity(GData& gterm, UInt mn, UInt mx) {
   return isGTerm(gterm) 
      && _TermArity(gterm) >= mn 
      && _TermArity(gterm) <= mx ;
} ;

inline bool chkHeadArity(GData& gterm, GData& head, UInt n) {
   return isGTerm(gterm) 
      && _TermHead(gterm) == head.val.symbol
      && _TermArity(gterm) == n ;
} ;
inline bool chkHeadArity(GData& gterm, GData& head, UInt mn, UInt mx) {
   return isGTerm(gterm) 
      && _TermHead(gterm) == head.val.symbol
      && _TermArity(gterm) >= mn 
      && _TermArity(gterm) >= mx ; 
} ;


inline InstGData _fetchedArgv(InstGData& igd, UInt n) {
   InstGData r = fetch(_TermArgv(igd.data, n),igd.binding) ;
   return r ;
} ;

inline GData fetchedArgv(InstGData& igd, UInt n) {
   return _fetchedArgv(igd,n).data ;
} ;

inline GData fetchedValueArgv(InstGData& igd,UInt n,Gem* gem) {
   return fetchValue(InstGData(_TermArgv(igd.data, n),igd.binding),
		     &(gem->uiheap)) ;
} ;

inline bool unifyWith(GData dt, const InstGData& var, Gem* gem) {
   /* dt should be atom */
   return unify(InstGData(dt,gem->currentGoal().binding),var,
		&(gem->uiheap)) ;
} ;
 

inline bool bipSuccess0(Gem *gem) {
   return true ;
} ;

inline bool bipSuccess(Gem *gem) {
   gem->popAndState() ;
   return bipSuccess0(gem) ;
} ;

inline bool bipFail(Gem *gem) {
   return false ;
} ;

inline bool bipError(Gem *gem, char* msg, InstGData& igd) {
   cerr << "Error: " << msg << ":" << fetchValue(igd,&gem->uiheap) << endl ;
//   gem->popAndState() ;
   return false ;
} ;
inline bool bipError(Gem *gem, char* msg) {
   return bipError(gem,msg,gem->currentGoal()) ;
}
   

